#ifndef NODE_H
#define NODE_H

template <class T>
class Set;

template <class T>
class Node {
public:
  T value;
  Node<T>* right;
  Node<T>* left;
  Node<T>* parent;
  friend Set<T>;
private:
  Node(T val=T(), Node<T>* rt=0, Node<T>* lt=0, Node<T>* pt=0);
  Node(const Node<T>& org);
  ~Node();
  Node<T>& operator=(const Node<T>& rhs);
};

template <class T>
Node<T>::Node(T val, Node<T>* rt, Node<T>* lt, Node<T>* pt) 
   : value(val), right(rt), left(lt), parent(pt)
{
}

template <class T>
Node<T>::Node(const Node<T>& org)
   : value(org.value), right(org.right), left(org.left), parent(org.parent)
{
}

template <class T>
Node<T>::~Node()
{
}

template <class T>
Node<T>& Node<T>::operator=(const Node<T>& rhs)
{
  value=rhs.value;
  right=rhs.right;
  left=rhs.left;
  parent=rhs.parent;
  return *this;
}

#endif